medux_online/plugins/prescriptions/urls.py
from django.urls import path, include

from medux_online.core.api.interfaces import IDashboardURL
from medux_online.plugins.prescriptions import views

app_name = "prescriptions"

urlpatterns = [
    # path("terms/", TermsView.as_view(), name="terms"),
    # path("privacy/", PrivacyView.as_view(), name="privacy"),
]

prescriptionrequest_patterns = [
    # request admin view is listed under /dashboard/requests/
    path("", views.PrescriptionRequestListView.as_view(), name="list"),
    path("<pk>/", views.PrescriptionRequestItemView.as_view(), name="detail"),
    path("<pk>/approve/", views.PrescriptionRequestApproveView.as_view(), name="approve"),
    path("<pk>/delete/", views.PrescriptionRequestDeleteView.as_view(), name="delete"),
]


class PrescriptionDashboardURLs(IDashboardURL):
    urlpatterns = [
        path(
            "prescriptionrequest/",
            include(
                (prescriptionrequest_patterns, "prescriptionrequest"),
                namespace="prescriptionrequest",
            ),
        )
    ]


# All following are patterns for generic medux.at URLs and not
# at a specific homepage, so they need a tenant_id
root_urlpatterns = [
    path(
        "tenant/<uuid:uuid>/prescriptionrequests/add",
        views.PrescriptionRequestCreateView.as_view(),
        name="prescriptionrequest-add",
    ),
    path(
        "tenant/<uuid:uuid>/prescriptionrequests/thanks/",
        views.ThanksView.as_view(),
        name="prescriptionrequest-thanks",
    ),
]

medux_online/urls.py
from functools import wraps

from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.core.exceptions import PermissionDenied
from django.urls import path, include
from gdaps.pluginmanager import PluginManager

from .core.api.interfaces import IDashboardURL
from .core.views import DashboardView

app_name = "medux_online"


def medux_site_required(test_func=None):
    """
    Decorator for views that checks that the current site is the main
    medux site. If not, raise a PermissionDenied error
    """

    def site_is_medux(view_func):
        @wraps(view_func)
        def _wrapped_view(request, *args, **kwargs):
            if request.site == 1:
                return True
            raise PermissionDenied

        return _wrapped_view

    return site_is_medux


# create a pluggable "dashboard" urlpatterns hook
dashboard_urlpatterns = [
    path("", DashboardView.as_view(), name="index"),
]
for up in IDashboardURL:
    dashboard_urlpatterns += up.urlpatterns

urlpatterns = [
    # TODO make admin only available on SIDE_ID=1
    path("admin/", admin.site.urls, name="admin"),
    path(
        "dashboard/",
        # dashboard is no namespace, only part of the URL
        include((dashboard_urlpatterns, ""), namespace=""),
        name="index",
    ),
    path("__debug__/", include("debug_toolbar.urls")),
] + PluginManager.urlpatterns()

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

medux_online/plugins/prescriptions/models.py
from django.core.exceptions import ValidationError
from django.core.validators import MinLengthValidator
from django.db import models
from django.utils import timezone
from django.utils.translation import gettext_lazy as _

from medux.common.models import TenantModelMixin, CreatedModifiedModel


# www.sozialversicherung.at/HELP/VSNR/VSNR_1.htm
def validate_svnr(value: str):
    if len(value) != 10:
        raise ValidationError(_("SVNR must have 10 digits."))
    if not value.isnumeric():
        raise ValidationError(_("SVNR must only contain digits."))

    if value[0] == "0":
        raise ValidationError(_("SVNR cannot start with '0'."))

    weights = (3, 7, 9, None, 5, 8, 4, 2, 1, 6)
    sum = 0
    for index, c in enumerate(value):
        # multiple digits by specific "weight"
        if weights[index]:
            sum += int(c) * weights[index]

    # Prüfziffer = Gewichtete Summe MOD 11
    mod = sum % 11
    if int(value[3]) != mod:
        raise ValidationError(_("SVNR not valid."))

    if int(value[4:6]) > 31:  # day
        raise ValidationError(_("Day of birth date can not be higher than 31."))


class PrescriptionRequest(CreatedModifiedModel, TenantModelMixin):
    """A patient's request for a medication prescription."""

    class Meta:
        permissions = [
            ("approve_prescriptionrequest", _("Can approve prescription requests"))
        ]
        verbose_name = _("Prescription request")
        verbose_name_plural = _("Prescription requests")

    # user = models.ForeignKey(
    #     User,
    #     on_delete=models.CASCADE,
    #     blank=True,
    #     null=True,
    # )
    last_name = models.CharField(verbose_name=_("Last name"), max_length=100)
    "Last name! of the patient."

    first_name = models.CharField(verbose_name=_("First name"), max_length=100)
    "First name! of the patient."

    insurance_number = models.CharField(
        max_length=10,
        validators=[MinLengthValidator(10), validate_svnr],
        verbose_name=_("Insurance number"),
    )
    "Austrian insurance number of the patient."

    comment = models.TextField(
        blank=True,
        help_text=_("Please enter your medication requests here."),
    )
    "A general comment. This is abused as medication fill-in ATM."

    internal_comment = models.CharField(
        blank=True, verbose_name=_("Internal Comment"), max_length=300
    )
    approved = models.BooleanField(default=False, verbose_name=_("Approved"))
    "Whether this request was approved by a person with sufficient rightts."

    def __str__(self):
        return f"{self.last_name.upper()}, {self.first_name}, {self.insurance_number}"

    def priority(self):
        """Returns a (configurable) priority for this instance.

        This is used for ordering.
        :return: a str with an integer from 1 - 5, which represents
        low - high priority
        """
        # TODO: make it configureable via settings: (1,2,5
        timediff = timezone.now() - self.created
        if timediff.total_seconds() < 1 * 60 * 60:  # <1 hour
            return 1
        elif timediff.total_seconds() < 2 * 60 * 60:  # <2 hours
            return 2
        elif timediff.total_seconds() < 5 * 60 * 60:  # <5 hours
            return 3
        elif timediff.total_seconds() < 24 * 60 * 60:  # <24 hours
            return 4
        # > 24 hrs
        return 5

    def clean(self):
        """Strips all CharFields."""
        self.first_name = self.first_name.strip()
        self.last_name = self.last_name.strip()
        self.insurance_number = self.insurance_number.strip()


class Medication(models.Model):
    name = models.CharField(_("Medication"), max_length=255)
    pkgs = models.PositiveSmallIntegerField(default=1)
    signature = models.CharField(max_length=100)
    request = models.ForeignKey(PrescriptionRequest, on_delete=models.CASCADE)

    def __str__(self):
        return f"{self.name}, OP {self.pkgs}, S: {self.signature}"

medux_online/plugins/prescriptions/forms.py
from crispy_forms.bootstrap import FormActions
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Layout, Submit, Row, Field, Column, HTML
from django import forms
from django.forms import modelformset_factory
from django.utils.translation import gettext_lazy as _

# from medux_online.core.forms import TenantFormMixin
from medux_online.plugins.prescriptions.models import Medication, PrescriptionRequest

MedicationFormSet = modelformset_factory(
    model=Medication,
    fields=("name", "pkgs"),
    min_num=1,
)


class PrescriptionRequestForm(forms.ModelForm):  # TenantFormMixin
    class Meta:
        model = PrescriptionRequest
        fields = ["first_name", "last_name", "insurance_number", "comment"]

    insurance_number = forms.CharField(
        min_length=10,
        max_length=10,
        widget=forms.TextInput(attrs={"placeholder": "0000TTMMYY", "class": ""}),
        label=_("Insurance number"),
    )
    # password = forms.PasswordInput()

    # medication_formset = MedicationFormSet()
    comment = forms.CharField(
        widget=forms.Textarea(
            attrs={
                "placeholder": _("e.g.: \nAmlodipin 5mg, 1 pkg,\n2x Thyrex 100 ,\n...")
            }
        ),
        label=_("Medication"),
        help_text=_(
            "Please enter the exact medication names, dosages and package counts."
        ),
    )

    helper = FormHelper()
    helper.layout = Layout(
        Row(
            Column(
                Field("first_name", css_class="form-control-lg"),
                css_class="col-12 col-lg-4 responsive",
            ),
            Column(
                Field("last_name", css_class="form-control-lg"),
                css_class="col-12 col-lg-4 responsive",
            ),
            Column(
                Field("insurance_number", css_class="form-control-lg"),
                css_class="col-12 col-lg-4 responsive",
            ),
        ),
        Row(
            Column(
                HTML(
                    "{% if preferences.prescriptions.show_medication_message %}"
                    "<div class='alert alert-warning'>"
                    "{{ preferences.prescriptions.medication_message }}"
                    "</div>"
                    "{% endif %}"
                )
            )
        ),
        Row(
            Column(
                Field("comment", css_class="form-control-lg responsive", rows="5"),
                css_class="col-12 responsive",
            ),
        ),
        FormActions(
            Submit("submit", _("Send"), css_class="btn-prescription"),
        ),
    )

medux_online/plugins/prescriptions/views.py
from django.contrib import messages
from django.contrib.auth.mixins import PermissionRequiredMixin
from django.core.exceptions import PermissionDenied
from django.http import HttpResponseRedirect
from django.urls import reverse
from django.utils.translation import gettext_lazy as _
from django.views.generic import (
    CreateView,
    TemplateView,
    ListView,
    DetailView,
    DeleteView,
)

from medux.common.api.http import HttpResponseEmpty
from medux.common.htmx.mixins import HtmxResponseMixin
from medux.common.mixins import TenantPermissionRequiredMixin
from medux.common.models import Tenant
from medux.common.views import DashboardMixin
from medux.preferences.cached_preferences import CachedPreferences
from medux.preferences.definitions import Scope
from medux_online.core.views import TenantRequestMixin
from medux_online.core.models import User
from medux_online.plugins.prescriptions.forms import PrescriptionRequestForm
from medux_online.plugins.prescriptions.models import PrescriptionRequest


class PrescriptionRequestListView(
    PermissionRequiredMixin, TenantRequestMixin, DashboardMixin, ListView
):
    """Shows a list of prescription requests, and some editing actions."""

    model = PrescriptionRequest
    template_name = "prescriptions/prescription_request_list.html"
    permission_required = "prescriptions.view_prescriptionrequest"
    paginate_by = 10
    ordering = ["created"]


class PrescriptionRequestItemView(
    PermissionRequiredMixin, HtmxResponseMixin, DetailView
):
    model = PrescriptionRequest
    template_name = "prescriptions/prescription_request_item.html"
    permission_required = "prescriptions.view_prescriptionrequest"
    enforce_htmx = True

    def has_permission(self):
        user: User = self.request.user
        # self.object.tenant == user.tenant and
        if not type(self.permission_required) == list:
            self.permission_required = [self.permission_required]
        return user.has_perms(self.permission_required)


class PrescriptionRequestApproveView(
    TenantPermissionRequiredMixin, HtmxResponseMixin, DetailView
):
    model = PrescriptionRequest
    permission_required = "prescriptions.approve_prescriptionrequest"
    enforce_htmx = True


class PrescriptionRequestDeleteView(
    TenantPermissionRequiredMixin, HtmxResponseMixin, DeleteView
):
    model = PrescriptionRequest
    permission_required = "prescriptions.delete_prescriptionrequest"
    enforce_htmx = True

    def form_valid(self, form):
        # self.object.delete()
        messages.success(
            self.request, "Prescription request deleted.", extra_tags="dismissible"
        )
        return HttpResponseEmpty(
            headers={"HX-Trigger": "medux:prescriptionrequest:deleted"}
        )


class PrescriptionRequestCreateView(PermissionRequiredMixin, CreateView):
    """Let's anonymous users create prescription requests in a form."""

    model = PrescriptionRequest
    form_class = PrescriptionRequestForm
    template_name = "prescriptions/prescriptionrequest_form.html"

    def has_permission(self):
        """Don't allow prescription requests on MedUX main site admin."""

        if self.request.site.pk != 1:
            raise PermissionDenied(
                _("There are no prescription requests allowed on this site.")
            )
        return True

    def get_success_url(self):
        return reverse(
            "prescriptionrequest-thanks",
            kwargs={"uuid": self.kwargs.get("uuid")},
        )

    def get_context_data(self, **kwargs):
        """Add url's tenant to context"""
        context = super().get_context_data(**kwargs)
        tenant = Tenant.objects.get(uuid=self.kwargs.get("uuid"))
        if tenant.id == 1:
            # Admin does not use prescriptions...
            raise PermissionDenied
        context.update({"tenant": tenant})
        return context

    def form_valid(self, form):
        prescription_request = form.save(commit=False)
        prescription_request.tenant = Tenant.objects.get(uuid=self.kwargs.get("uuid"))
        prescription_request.save()
        return HttpResponseRedirect(self.get_success_url())


class ThanksView(TemplateView):
    template_name = "prescriptions/thanks.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        tenant = Tenant.objects.get(uuid=self.kwargs.get("uuid"))

        thanks_message = CachedPreferences.get(
            "prescriptions", "thanks_message", Scope.TENANT, tenant=tenant
        ) or CachedPreferences.get("prescriptions", "thanks_message", Scope.VENDOR)

        context.update({"tenant": tenant, "thanks_message": thanks_message})
        return context

medux_online/plugins/prescriptions/templates/prescriptions/base.html
{% extends "core/page.html" %}
{% load i18n static %}

{% block styles %}
    <link rel="stylesheet" href="{% static 'prescriptions/css/prescriptions.css' %}">
{% endblock %}

medux_online/plugins/prescriptions/templates/prescriptions/cart.html
<div class="row g-5">
  <div class="col-md-5 col-lg-4 order-md-last">
    <h4 class="d-flex justify-content-between align-items-center mb-3">
      <span class="text-primary">Your requests</span>
      <span class="badge bg-primary rounded-pill">{{ prescriptionrequest.medication_set.all |length }}</span>
    </h4>
    <ul class="list-group mb-3">
      {% for medication in prescriptionrequest.medication_set.all %}
        <li class="list-group-item d-flex justify-content-between lh-sm">
          <div>
            <h6 class="my-0">{{ medication }}</h6>
            <small class="text-muted">Brief description</small>
          </div>

          <span class="text-muted">OP {{ medication.pkgs }}</span>

        </li>
      {% endfor %}

      {# TODO: remove example code #}
      <li class="list-group-item d-flex justify-content-between lh-sm">
        <div>
          <h6 class="my-0">Amlodipin 5mg Tbl</h6>
          <small class="text-muted">1-0-0</small>
        </div>
        <span class="text-muted">OP 2</span>
      </li>
      <li class="list-group-item d-flex justify-content-between lh-sm">
        <div>
          <h6 class="my-0">Gabapentin 300mg Tbl</h6>
          <small class="text-muted">1-1-1</small>
        </div>
        <span class="text-muted">OP 1</span>
        <div>
          <button
              class="btn btn-secondary"
              hx-post="{% url 'prescriptions:delete-medication' %}"
          ><i class="bi bi-x-circle"></i></button>
        </div>
      </li>
    </ul>
  </div>

medux_online/plugins/prescriptions/templates/prescriptions/prescription_request_item.html
{% load i18n %}
{# represents one table row with a PR item #}
{# :param object: the PrescriptionRequest to display #}

<tr id="request-item-{{ object.pk }}" hx-swap-oob="beforeend"
    class="{% if perms.prescriptions.approve_prescriptionrequest and not object.approved %} text-black-50{% endif %}">
  {# status #}
  <td class="d-none d-md-table-cell">
    <span class="status-dot bg-priority-{{ object.priority }} d-block{% if object.priority == 5 %} status-dot-animated{% endif %}"></span>
  </td>
  <td class="d-none d-md-table-cell">
    <div>{{ object.created | timesince }}</div>
    <div class="small text-black-50">{{ object.created }}</div>
  </td>
  <td>{{ object.last_name | upper }}, {{ object.first_name }}<br/>
    <div class="text-black-50">{{ object.insurance_number }}</div>
  </td>

  {# comment field misused as freetext request #}
  <td class="text-wrap">{{ object.comment }}</td>

  <td class="d-none d-md-table-cell">{{ object.internal_comment }}</td>

  {# actions #}
  <td>

    {% if preferences.prescriptions.use_approval %}
      {% if perms.prescriptions.approve_prescriptionrequest %}
        {% if not object.approved %}
          <button class="btn btn-sm btn-success" hx-post="{%  url 'prescriptionrequest:approve' object.pk %}">
            {% translate "Approve" %}
          </button>
        {% endif %}
      {% endif %}
    {% endif %}
    {% if not preferences.prescriptions.use_approval or preferences.prescriptions.use_approval and object.approved %}
      {% if perms.prescriptions.delete_prescriptionrequest %}
        <button class="btn btn-sm btn-success" hx-post="{%  url 'prescriptionrequest:delete' object.pk %}">
          {% translate "Done" %}
        </button>
      {% endif %}
    {% endif %}

  </td>
</tr>

medux_online/plugins/prescriptions/templates/prescriptions/prescription_request_list.html
{% extends "prescriptions/base.html" %}
{% load crispy_forms_tags i18n breadcrumbs %}

{% block title %}{% translate 'Medication requests' %}{% endblock %}
{% block page_title %}{% translate 'Medication requests' %}{% endblock %}

{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb "Prescription requests" "prescriptionrequest:list" %}
{% endblock %}

{% block content %}
  <div id="prescriptionrequest-list"
       hx-get="{% url 'prescriptionrequest:list' %}"
       hx-trigger="medux:prescriptionrequest:added from:body, medux:prescriptionrequest:deleted from:body"
       hx-disinherit="*"
       hx-select="#prescriptionrequest-list"
       hx-target="this"
  >
    <div class="row">
      <div class="col-12">
        {% if not object_list %}
          <div class="alert alert-info">
            {% translate 'No pending requests' %}
          </div>
        {% else %}
          {% if request.user.tenant %}

            <div class="card">
              <div class="table-responsive">
                <table class="table card-table table-vcenter text-nowrap datatable">
                  <thead>
                  <tr>
                    <th class="d-none d-md-table-cell"></th>
                    <th class="w-1 d-none d-md-table-cell">{% translate 'Received' %}</th>
                    <th>{% translate 'Name' %}</th>
                    <th>{% translate 'Medication request' %}</th>
                    <th class="d-none d-md-table-cell">{% translate 'Internal Comment' %}</th>
                    <th>{% translate 'Actions' %}</th>
                  </tr>
                  </thead>
                  <tbody hx-ext="ws" ws-connect="/ws/notifications">
                  {% for object in object_list %}
                    {% include 'prescriptions/prescription_request_item.html' with object=object %}
                  {% endfor %}
                  </tbody>
                </table>
              </div>

              <div class="card-footer d-flex align-items-center">
                <p class="m-0 text-muted">{% blocktranslate with current=page_obj.number num_pages=page_obj.paginator.num_pages %}Page <span>{{ current }}</span> of <span>{{ num_pages }}</span>{% endblocktranslate %}</p>
                <ul class="pagination m-0 ms-auto">
                  <li class="page-item">
                    {#              <a class="page-link" href="?page=1" tabindex="-1" aria-disabled="true">#}
                    {#                <i class="bi bi-chevron-double-left"></i> {% translate 'first' %}#}
                    {#              </a>#}
                    <a
                        class="page-link{% if not page_obj.has_previous %} disabled{% endif %}"
                        href="{% if page_obj.has_previous %}?page={{ page_obj.previous_page_number }}{% else %}#{% endif %}" tabindex="-1" aria-disabled="true">
                      <i class="bi bi-chevron-left"></i> {% translate 'prev' %}
                    </a>
                  </li>
                  {% for num_page in paginator.get_elided_page_range %}
                    <li class="page-item{% if page_obj.number == num_page %} active{% endif %}"><a class="page-link" href="?page={{ num_page }}">{{ num_page }}</a></li>
                  {% endfor %}

                  <li class="page-item{% if not page_obj.has_next %} disabled{% endif %}">
                    <a class="page-link"
                       href="{% if page_obj.has_next %}?page={{ page_obj.next_page_number }}{% else %}#{% endif %}">
                      {% translate 'next' %} <i class="bi bi-chevron-right"></i>
                    </a>
                    {#              <a class="page-link" href="?page={{ page_obj.paginator.num_pages }}">#}
                    {#                {% translate 'last' %} <i class="bi bi-chevron-double-right"></i>#}
                    {#              </a>#}
                  </li>
                </ul>
              </div>
            </div>

          {% else %} {# user.tenant is None: Admin! #}
            <div class="alert alert-warning">
              {% blocktranslate trimmed with user=request.user %}
                Your current user ({{ user }}) is not attached to a tenant.
                Therefore, you cannot access your tenant's prescription requests.
                Please log in as a user that is attached to a tenant.
              {% endblocktranslate %}
            </div>
          {% endif %}
        {% endif %}
      </div>
    </div>
  </div>
{% endblock %}

medux_online/plugins/prescriptions/templates/prescriptions/prescriptionrequest_form.html
{% extends "core/staticpage.html" %}
{% load crispy_forms_tags i18n %}

{% block title %}
  {% translate 'Practice:' %} {% blocktranslate %}Medication requests for {{ tenant }}{% endblocktranslate %}
{% endblock %}

{% block page_title %}
  {% blocktranslate %}Medication requests for {{ tenant }}{% endblocktranslate %}
{% endblock %}

{% block nav_buttons %}
  {% with request.user as user %}
    {% if user.is_authenticated %}
      <div class="text-muted"><i class="bi bi-person"></i> {{ user }}
        <a class="btn btn-sm btn-outline-secondary" href="{% url 'index' %}">{% translate 'Dashboard' %}</a></div>
    {% endif %}
  {% endwith %}
  {#  <a href="#" class="btn" target="_blank" rel="noreferrer">#}
{#    Source code#}
{#  </a>#}
{#  <a href="#" class="btn" target="_blank" rel="noreferrer">#}
{#    Sponsor#}
{#  </a>#}
{% endblock %}

{#{% block header_bg_color %}blue{% endblock %}#}

{% block content %}
  <div class="row row-cards">
    <div class="col-12">
      <div class="card">
{#        <div class="card-header">#}
{#          <h3 class="card-title">{% blocktranslate %}Medication requests for {{ tenant }}{% endblocktranslate %}</h3>#}
{#        </div>#}
        <div class="card-body">
          {% crispy form %}
        </div>
      </div>
    </div>
  </div>
{% endblock %}

medux_online/plugins/prescriptions/templates/prescriptions/thanks.html
{% extends "common/empty.html" %}
{% load i18n crispy_forms_tags %}

{% block content %}
  <div class="row m-5 d-flex justify-content-center">
    <div class="col-6">
      <div class="card">
        <div class="card-body">
          <p class="card-text">{{ thanks_message }}</p>
          <div class="text-center">
            {# TODO: add logo / CI here #}
            {{ tenant.title }} {{ tenant.first_name }} {{ tenant.last_name }}
          </div>
        </div>
          <a class="btn btn-primary autofocus w-100" href="{% url 'prescriptionrequest-add' tenant.uuid %}">{% translate 'New request' %}</a>
      </div>
    </div>
  </div>
{% endblock %}